## elastix 4.4

=== CMakeLists.txt ===
#---------------------------------------------------------------------
CMAKE_MINIMUM_REQUIRED( VERSION 2.8 )
CMAKE_POLICY( SET CMP0012 NEW )

#---------------------------------------------------------------------
PROJECT( elastix )

#---------------------------------------------------------------------
# Find ITK.
FIND_PACKAGE( ITK REQUIRED )
IF( ITK_FOUND )
  INCLUDE( ${ITK_USE_FILE} )
ENDIF( ITK_FOUND )

#---------------------------------------------------------------------
# Find CUDA.
MARK_AS_ADVANCED( ELASTIX_USE_CUDA )
OPTION( ELASTIX_USE_CUDA "Use CUDA enabled GPU" OFF )

IF( ELASTIX_USE_CUDA )
  FIND_PACKAGE( CUDA REQUIRED )

	MARK_AS_ADVANCED( CUDA_BUILD_CUBIN )
	MARK_AS_ADVANCED( CUDA_BUILD_EMULATION )
	MARK_AS_ADVANCED( CUDA_VERBOSE_BUILD )
	MARK_AS_ADVANCED( CUDA_SDK_ROOT_DIR )
ENDIF()

#----------------------------------------------------------------------
# Mark some mostly unused variables as advanced
MARK_AS_ADVANCED( EXECUTABLE_OUTPUT_PATH )
MARK_AS_ADVANCED( LIBRARY_OUTPUT_PATH )

#---------------------------------------------------------------------
# Check if Mevis DicomTiff support is desired
MARK_AS_ADVANCED( ELASTIX_USE_MEVISDICOMTIFF )
OPTION( ELASTIX_USE_MEVISDICOMTIFF
  "Support MevisLab DicomTiff image format" OFF )

#----------------------------------------------------------------------
# Define cmake variable to define extra user component directories
# These directories will be added to the list of include directories
# and they will be searched for CMakeLists.txt files for further
# processing. In these directories, users may put code for their own
# components.

MARK_AS_ADVANCED( ELASTIX_USER_COMPONENT_DIRS )
SET( ELASTIX_USER_COMPONENT_DIRS "" CACHE PATH "directories with user defined elastix components" )

#-------------------------------------------------------------------------
# elastix depends on some ITK settings

IF( NOT ITK_USE_REVIEW )
  message( SEND_ERROR "ITK_USE_REVIEW has not been set to ON when compiling ITK. This option is mandatory for elastix to build.\nPlease recompile your ITK installation." )
ENDIF()

IF( NOT ITK_USE_REVIEW_STATISTICS )
  message( SEND_ERROR "ITK_USE_REVIEW_STATISTICS has not been set to ON when compiling ITK. This option is mandatory for elastix to build.\nPlease recompile your ITK installation." )
ENDIF()

# This variable seems to be internal
#IF( NOT ITK_IMAGE_BEHAVES_AS_ORIENTED_IMAGE )
#  message( SEND_ERROR "ITK_IMAGE_BEHAVES_AS_ORIENTED_IMAGE has not been set to ON when compiling ITK. This option is mandatory for elastix to build.\nPlease recompile your ITK installation." )
#ENDIF()

IF( NOT ITK_USE_ORIENTED_IMAGE_DIRECTION )
  message( SEND_ERROR "ITK_USE_ORIENTED_IMAGE_DIRECTION has not been set to ON when compiling ITK. This option is mandatory for elastix to build.\nPlease recompile your ITK installation." )
ENDIF()

# This variable seems to be internal
#IF( NOT ITK_USE_CENTERED_PIXEL_COORDINATES_CONSISTENTLY )
# message( SEND_ERROR "ITK_USE_CENTERED_PIXEL_COORDINATES_CONSISTENTLY has not been set to ON when compiling ITK. This option is mandatory for elastix to build.\nPlease recompile your ITK installation." )
#ENDIF()

#---------------------------------------------------------------------
# If IDE supports it, do use folder view.

SET_PROPERTY( GLOBAL PROPERTY USE_FOLDERS ON )

#---------------------------------------------------------------------
# Include directories

SET( elxCommon_INCLUDE_DIRECTORIES
  ${elastix_SOURCE_DIR}/Common
  ${elastix_SOURCE_DIR}/Common/CostFunctions
  ${elastix_SOURCE_DIR}/Common/CUDA
  ${elastix_SOURCE_DIR}/Common/ImageSamplers
  ${elastix_SOURCE_DIR}/Common/KNN
  ${elastix_SOURCE_DIR}/Common/KNN/ann_1.1/include
  ${elastix_SOURCE_DIR}/Common/LineSearchOptimizers
  ${elastix_SOURCE_DIR}/Common/ParameterFileParser
  ${elastix_SOURCE_DIR}/Common/Transforms
  ${elastix_SOURCE_DIR}/Common/xout
  ${elastix_SOURCE_DIR}/Common/MevisDicomTiff
)

SET( elxCore_INCLUDE_DIRECTORIES
  ${elastix_SOURCE_DIR}/Core
  ${elastix_SOURCE_DIR}/Core/Install
  ${elastix_SOURCE_DIR}/Core/Kernel
  ${elastix_SOURCE_DIR}/Core/ComponentBaseClasses
  ${elastix_SOURCE_DIR}/Core/Configuration
  ${elastix_SOURCE_DIR}/Core/Main
)

SET( elxComponents_INCLUDE_DIRECTORIES
  ${elastix_SOURCE_DIR}/Components/FixedImagePyramids
  ${elastix_SOURCE_DIR}/Components/ImageSamplers
  ${elastix_SOURCE_DIR}/Components/Interpolators
  ${elastix_SOURCE_DIR}/Components/Metrics
  ${elastix_SOURCE_DIR}/Components/MovingImagePyramids
  ${elastix_SOURCE_DIR}/Components/Optimizers
  ${elastix_SOURCE_DIR}/Components/Registrations
  ${elastix_SOURCE_DIR}/Components/ResampleInterpolators
  ${elastix_SOURCE_DIR}/Components/Resamplers
  ${elastix_SOURCE_DIR}/Components/Transforms
)

SET( elxINCLUDE_DIRECTORIES
  ${elxCommon_INCLUDE_DIRECTORIES}
  ${elxCore_INCLUDE_DIRECTORIES}
  ${elxComponents_INCLUDE_DIRECTORIES}
  ${elastix_BINARY_DIR}
  ${ELASTIX_USER_COMPONENT_DIRS}
)

INCLUDE_DIRECTORIES( ${elxINCLUDE_DIRECTORIES} )

#---------------------------------------------------------------------
# Kill the anoying MS VS warning about non-safe functions.
# They hide real warnings.
IF( MSVC )
  ADD_DEFINITIONS(
    /D_SCL_SECURE_NO_DEPRECATE
    /D_CRT_SECURE_NO_DEPRECATE
    /D_CRT_TIME_FUNCTIONS_NO_DEPRECATE
  )
  # Increases address capacity
  IF ( WIN32 )
    SET( CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /bigobj" )
    SET( CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /bigobj" )
  ENDIF()
ENDIF()

#---------------------------------------------------------------------
# Process the sub-directories

# Common dir: code that is neither related to the core of elastix or
# to specific components.
ADD_SUBDIRECTORY( Common )

# Components: the registration components such as metrics, transforms,
# optimizers, etc.
ADD_SUBDIRECTORY( Components )

# Core dir: code that takes care of starting elastix, loading
# components, definitions of macros etc.
ADD_SUBDIRECTORY( Core )

#--------------------------------------------------------------------
# Configure the examples

SET( ELASTIX_DOX_DIR  ${elastix_SOURCE_DIR}/../dox )
SET( ELASTIX_HELP_DIR ${elastix_SOURCE_DIR}/../help CACHE PATH
  "path to the doxygen generated help files and the examples" )

# Copy the examples to the help directory

IF( WIN32 )
  CONFIGURE_FILE(
    ${ELASTIX_DOX_DIR}/example.bat
    ${ELASTIX_HELP_DIR}/example.bat
    COPYONLY )
ELSE()
  CONFIGURE_FILE(
    ${ELASTIX_DOX_DIR}/example
    ${ELASTIX_HELP_DIR}/example
    COPYONLY )
ENDIF()

MAKE_DIRECTORY( ${ELASTIX_HELP_DIR}/exampleinput )
MAKE_DIRECTORY( ${ELASTIX_HELP_DIR}/exampleoutput )

SET( ELX_EXAMPLEINPUTFILES
  fixed.mhd
  fixed.raw
  mask_fixed.mhd
  mask_fixed.raw
  mask_moving.mhd
  mask_moving.raw
  moving.mhd
  moving.raw
  parameters_Affine.txt
  parameters_BSpline.txt
  parameters_Rigid.txt
  parameters_Translation.txt
  solution_deformedmovingimage.mhd
  solution_deformedmovingimage.raw
)

FOREACH( ELX_EXAMPLEINPUTFILE ${ELX_EXAMPLEINPUTFILES} )
  CONFIGURE_FILE(
    ${ELASTIX_DOX_DIR}/exampleinput/${ELX_EXAMPLEINPUTFILE}
    ${ELASTIX_HELP_DIR}/exampleinput/${ELX_EXAMPLEINPUTFILE}
    COPYONLY )
ENDFOREACH()

#---------------------------------------------------------------------
# Get version information.

# Get the version number of elastix
FILE( STRINGS ${elastix_SOURCE_DIR}/Core/Install/elxBaseComponent.h
  ELASTIX_VERSION REGEX "\(#define\ __ELASTIX_VERSION\)" )
STRING( SUBSTRING ${ELASTIX_VERSION} 26 3 ELASTIX_VERSION )

# Split version in major minor. Assuming no patch number, just x.y
STRING( REGEX MATCH "[0-9]+" ELASTIX_VERSION_MAJOR "${ELASTIX_VERSION}" )
STRING( REGEX REPLACE "([0-9]+)\\." "" ELASTIX_VERSION_MINOR "${ELASTIX_VERSION}" )

#---------------------------------------------------------------------
# Configure the doxygen-configuration

FIND_PACKAGE( Doxygen QUIET )
STRING( COMPARE NOTEQUAL ${DOXYGEN} "DOXYGEN-NOTFOUND" Doxygen_FOUND )

IF( Doxygen_FOUND )

  # Set the path to the doxygen configuration source
  SET( ELASTIX_DOXYGEN_DIR ${ELASTIX_DOX_DIR}/doxygen )

  # Get the version number of doxygen
  EXEC_PROGRAM( ${DOXYGEN} ARGS "--version" OUTPUT_VARIABLE ELASTIX_DOXYGEN_VERSION )

  # Get date
  IF( UNIX OR CYGWIN )
    EXEC_PROGRAM( "date '+%d-%m-%Y'" OUTPUT_VARIABLE ELASTIX_DOXYGEN_DATE )
  ENDIF()
  IF( WIN32 )
    IF( NOT CYGWIN )
      EXECUTE_PROCESS( COMMAND "${ELASTIX_DOXYGEN_DIR}/doxdate.bat"
        OUTPUT_VARIABLE ELASTIX_DOXYGEN_DATETEMP )
      STRING( REPLACE "/" "-" ELASTIX_DOXYGEN_DATE ${ELASTIX_DOXYGEN_DATETEMP} )
    ENDIF()
  ENDIF()

  # Configure the doxygen configuration
  CONFIGURE_FILE(
    ${ELASTIX_DOXYGEN_DIR}/doxyfile.in
    ${ELASTIX_HELP_DIR}/doxyfile.out @ONLY )
  # Configure the footer of the help website.
  CONFIGURE_FILE(
    ${ELASTIX_DOXYGEN_DIR}/DoxygenFooter.html.in
    ${ELASTIX_HELP_DIR}/DoxygenFooter.html @ONLY )
  # Configure the MainPage.dox
  CONFIGURE_FILE(
    ${ELASTIX_DOXYGEN_DIR}/MainPage.dox.in
    ${ELASTIX_HELP_DIR}/MainPage.dox @ONLY )

ENDIF()

#---------------------------------------------------------------------
# Testing

SET( ELASTIX_BUILD_TESTING OFF CACHE BOOL
  "Perform some tests on basic functionality of elastix." )
IF( ELASTIX_BUILD_TESTING )
  ENABLE_TESTING()
  ADD_SUBDIRECTORY( Testing )
ENDIF()

#---------------------------------------------------------------------
# Packaging

MARK_AS_ADVANCED( ELASTIX_ENABLE_PACKAGER )
OPTION( ELASTIX_ENABLE_PACKAGER "Enable elastix packager using CPack" OFF )

IF( ELASTIX_ENABLE_PACKAGER )
  # Version information
  # If the next line is uncommented the package name will be like
  # elastix-4.3-win64 instead of elastix-4.3.0-win64
  #SET( CPACK_PACKAGE_VERSION ${ELASTIX_VERSION} )
  SET( CPACK_PACKAGE_VERSION_MAJOR ${ELASTIX_VERSION_MAJOR} )
  SET( CPACK_PACKAGE_VERSION_MINOR ${ELASTIX_VERSION_MINOR} )
  SET( CPACK_PACKAGE_VERSION_PATCH "0" )

  # Also install the copyright file, since when the user enables packaging
  # we assume that the package is meant to distribute.
  INSTALL( FILES "${elastix_SOURCE_DIR}/CopyrightElastix.txt" DESTINATION . )

  # We have split the elastix package into two components:
  # - the core: elastix and transformix
  # - the libraries: ANNlib and cudart when ELASTIX_USE_CUDA ON
  # NOTE: Currently does not work for nsis. A bug related to this
  # seems to be fixed in the upcoming CMake 2.8.3
  # Therefore, disable component support for now.
  #SET( CPACK_COMPONENTS_ALL core libraries Unspecified )
  #  CPACK_ADD_COMPONENT( core
  #  "Core files"
  #  DESCRIPTION "Contains elastix and transformix"
  #  REQUIRED
  #  DEPENDS libraries )
#   [GROUP group]
#   [DEPENDS comp1 comp2 ... ]
#   [INSTALL_TYPES type1 type2 ... ]
#   [DOWNLOADED]
#   [ARCHIVE_FILE filename])
  #CPACK_ADD_COMPONENT( libraries
  #  "Libraries"
  #  DESCRIPTION "Contains the libraries"
  #  REQUIRED )
#SET( CPACK_COMPONENT_CORE_DISPLAY_NAME "Core files" )
#SET( CPACK_COMPONENT_LIBRARIES_DISPLAY_NAME "Libraries" )
#SET( CPACK_COMPONENT_CORE_DESCRIPTION "Contains elastix and transformix" )
#SET( CPACK_COMPONENT_LIBRARIES_DESCRIPTION "Contains the libraries" )
#SET( CPACK_COMPONENT_CORE_DEPENDS libraries )
#SET( CPACK_COMPONENT_CORE_REQUIRED ON )
#SET( CPACK_COMPONENT_LIBRARIES_REQUIRED ON )

  # The default package filename is
  # ${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}-${CPACK_SYSTEM_NAME}
  # which is like elastix-4.3.0-win64, or elastix-4.3.0-linux-i686
  # Currently however we use elastix_windows64_v4.3
  # We can change our naming schedule or come close to it using:
  #SET( CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}_${CPACK_SYSTEM_NAME}_v${CPACK_PACKAGE_VERSION}" )
  # but it doesn't work since these variables are not defined yet
  # Moving include(CPack) to above introduces other errors.
  #SET( CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}_${CMAKE_SYSTEM_NAME}_v${ELASTIX_VERSION}" )
  # also does not work properly. Just use the default for now.

  # General information
  SET( CPACK_PACKAGE_VENDOR "Stefan Klein and Marius Staring" )

=== Common/CMakeLists.txt ===
#---------------------------------------------------------------------
PROJECT( elxCommon )

#---------------------------------------------------------------------
# Sub-projects.

ADD_SUBDIRECTORY( ParameterFileParser )
ADD_SUBDIRECTORY( xout )

IF( USE_KNNGraphAlphaMutualInformationMetric )
  ADD_SUBDIRECTORY( KNN )
ENDIF()

IF( ELASTIX_USE_MEVISDICOMTIFF )
  ADD_SUBDIRECTORY( MevisDicomTiff )
ENDIF()

IF( ELASTIX_USE_CUDA )
  ADD_SUBDIRECTORY( CUDA )
ENDIF()

#---------------------------------------------------------------------
# Define lists of files in the subdirectories.

SET( CommonFiles
  elxTimer.cxx
  elxTimer.h
  itkImageFileCastWriter.h
  itkImageFileCastWriter.txx
  itkMeshFileReaderBase.h
  itkMeshFileReaderBase.txx
  itkMultiResolutionGaussianSmoothingPyramidImageFilter.h
  itkMultiResolutionGaussianSmoothingPyramidImageFilter.txx
  itkMultiResolutionImageRegistrationMethod2.h
  itkMultiResolutionImageRegistrationMethod2.txx
  itkNDImageBase.h
  itkNDImageTemplate.h
  itkNDImageTemplate.hxx
  itkScaledSingleValuedNonLinearOptimizer.cxx
  itkScaledSingleValuedNonLinearOptimizer.h
  itkTransformixInputPointFileReader.h
  itkTransformixInputPointFileReader.hxx
)

SET( MaskFiles
  itkImageMaskSpatialObject2.h
  itkImageMaskSpatialObject2.txx
  itkImageSpatialObject2.h
  itkImageSpatialObject2.txx
  itkErodeMaskImageFilter.h
  itkErodeMaskImageFilter.txx
  itkParabolicErodeDilateImageFilter.h
  itkParabolicErodeDilateImageFilter.txx
  itkParabolicErodeImageFilter.h
  itkParabolicMorphUtils.h
)

SET( CostFunctionFiles
  CostFunctions/itkAdvancedImageToImageMetric.h
  CostFunctions/itkAdvancedImageToImageMetric.hxx
  CostFunctions/itkExponentialLimiterFunction.h
  CostFunctions/itkExponentialLimiterFunction.hxx
  CostFunctions/itkHardLimiterFunction.h
  CostFunctions/itkHardLimiterFunction.hxx
  CostFunctions/itkImageToImageMetricWithFeatures.h
  CostFunctions/itkImageToImageMetricWithFeatures.txx
  CostFunctions/itkLimiterFunctionBase.h
  CostFunctions/itkMultiInputImageToImageMetricBase.h
  CostFunctions/itkMultiInputImageToImageMetricBase.txx
  CostFunctions/itkParzenWindowHistogramImageToImageMetric.h
  CostFunctions/itkParzenWindowHistogramImageToImageMetric.hxx
  CostFunctions/itkScaledSingleValuedCostFunction.cxx
  CostFunctions/itkScaledSingleValuedCostFunction.h
  CostFunctions/itkSingleValuedPointSetToPointSetMetric.h
  CostFunctions/itkSingleValuedPointSetToPointSetMetric.txx
  CostFunctions/itkTransformPenaltyTerm.h
  CostFunctions/itkTransformPenaltyTerm.txx
)

SET( TransformFiles
  Transforms/itkAdvancedBSplineDeformableTransformBase.h
  Transforms/itkAdvancedBSplineDeformableTransformBase.txx
  Transforms/itkAdvancedBSplineDeformableTransform.h
  Transforms/itkAdvancedBSplineDeformableTransform.txx
  Transforms/itkAdvancedCombinationTransform.h
  Transforms/itkAdvancedCombinationTransform.hxx
  Transforms/itkAdvancedIdentityTransform.h
  Transforms/itkAdvancedMatrixOffsetTransformBase.h
  Transforms/itkAdvancedMatrixOffsetTransformBase.txx
  Transforms/itkAdvancedRigid2DTransform.h
  Transforms/itkAdvancedRigid2DTransform.txx
  Transforms/itkAdvancedRigid3DTransform.h
  Transforms/itkAdvancedRigid3DTransform.txx
  Transforms/itkAdvancedTransform.h
  Transforms/itkAdvancedTransform.txx
  Transforms/itkBSplineDerivativeKernelFunction2.h
  Transforms/itkBSplineInterpolationDerivativeWeightFunction.h
  Transforms/itkBSplineInterpolationDerivativeWeightFunction.txx
  Transforms/itkBSplineInterpolationSecondOrderDerivativeWeightFunction.h
  Transforms/itkBSplineInterpolationSecondOrderDerivativeWeightFunction.txx
  Transforms/itkBSplineInterpolationWeightFunction2.h
  Transforms/itkBSplineInterpolationWeightFunction2.txx
  Transforms/itkBSplineInterpolationWeightFunctionBase.h
  Transforms/itkBSplineInterpolationWeightFunctionBase.txx
  Transforms/itkBSplineKernelFunction2.h
  #Transforms/itkBSplineSecondOrderDerivativeKernelFunction.h
  Transforms/itkBSplineSecondOrderDerivativeKernelFunction2.h
  Transforms/itkTransformToDeterminantOfSpatialJacobianSource.h
  Transforms/itkTransformToDeterminantOfSpatialJacobianSource.txx
  Transforms/itkTransformToSpatialJacobianSource.h
  Transforms/itkTransformToSpatialJacobianSource.txx
  Transforms/itkGridScheduleComputer.h
  Transforms/itkGridScheduleComputer.txx
  Transforms/itkUpsampleBSplineParametersFilter.h
  Transforms/itkUpsampleBSplineParametersFilter.txx
)

SET( LineSearchOptimizersFiles
  LineSearchOptimizers/itkMoreThuenteLineSearchOptimizer.h
  LineSearchOptimizers/itkMoreThuenteLineSearchOptimizer.cxx
  LineSearchOptimizers/itkLineSearchOptimizer.h
  LineSearchOptimizers/itkLineSearchOptimizer.cxx
)

SET( ImageSamplersFiles
  ImageSamplers/itkImageFullSampler.h
  ImageSamplers/itkImageFullSampler.txx
  ImageSamplers/itkImageGridSampler.h
  ImageSamplers/itkImageGridSampler.txx
  ImageSamplers/itkImageRandomCoordinateSampler.h
  ImageSamplers/itkImageRandomCoordinateSampler.txx
  ImageSamplers/itkImageRandomSampler.h
  ImageSamplers/itkImageRandomSampler.txx
  ImageSamplers/itkImageRandomSamplerBase.h
  ImageSamplers/itkImageRandomSamplerSparseMask.h
  ImageSamplers/itkImageRandomSamplerSparseMask.txx
  ImageSamplers/itkImageSample.h
  ImageSamplers/itkImageSamplerBase.h
  ImageSamplers/itkImageSamplerBase.txx
  ImageSamplers/itkImageToVectorContainerFilter.h
  ImageSamplers/itkImageToVectorContainerFilter.txx
  ImageSamplers/itkMultiInputImageRandomCoordinateSampler.h
  ImageSamplers/itkMultiInputImageRandomCoordinateSampler.txx
  ImageSamplers/itkVectorContainerSource.h
  ImageSamplers/itkVectorContainerSource.txx
  ImageSamplers/itkVectorDataContainer.h
  ImageSamplers/itkVectorDataContainer.txx
)

#---------------------------------------------------------------------
# Construct source groups for nice visualisation in Visual Studio.

SOURCE_GROUP( "Masks" FILES ${MaskFiles} )
SOURCE_GROUP( "CostFunctions" FILES ${CostFunctionFiles} )
SOURCE_GROUP( "Transforms" FILES ${TransformFiles} )
SOURCE_GROUP( "LineSearchOptimizers" FILES ${LineSearchOptimizersFiles} )
SOURCE_GROUP( "ImageSamplers" FILES ${ImageSamplersFiles} )

#---------------------------------------------------------------------
# Create the elxCommon library.

ADD_LIBRARY( elxCommon
  ${MaskFiles}
  ${CommonFiles}
  ${CostFunctionFiles}
  ${TransformFiles}
  ${LineSearchOptimizersFiles}
  ${ImageSamplersFiles}
)

#---------------------------------------------------------------------
# Link against other libraries.

TARGET_LINK_LIBRARIES( elxCommon
  ITKBasicFilters
  ITKNumerics
  ITKIO
  ITKCommon
)

=== Components/CMakeLists.txt ===
#---------------------------------------------------------------------
# Sub project name

PROJECT( elxComponents )

#---------------------------------------------------------------------
# Set the libraries to be linked.

# Linux gave an error, if param was linked. This was only
# when we still used .dll's. I'm not sure if it will still
# give an error, but as long as linux does not complain
# about the missing param, just leave it out.
IF( UNIX )
  IF ( NOT APPLE )
    SET(elxLinkLibs
      xoutlib
      elxCommon
      elxCore
      ITKBasicFilters
      ITKNumerics
      ITKIO
      ITKCommon
      ITKStatistics )
  ENDIF( NOT APPLE )
ENDIF( UNIX )

# Interestingly, visual c++ and MAC-GCC do need param
IF( WIN32 OR APPLE )
  SET( elxLinkLibs
    param
    xoutlib
    elxCommon
    elxCore
    ITKBasicFilters
    ITKNumerics
    ITKIO
    ITKCommon
    ITKStatistics )
ENDIF( WIN32 OR APPLE )

#--------------------------------------------------------------------
# Prepare elxInstallComponentFunctionDeclarations.h and
# elxInstallComponentFunctionCalls.h
# In the ADD_ELXCOMPONENT macro a line is added
#

SET( InstallFunctionDeclarationFile
  ${elastix_BINARY_DIR}/elxInstallComponentFunctionDeclarations.h )
SET( InstallFunctionCallFile
  ${elastix_BINARY_DIR}/elxInstallComponentFunctionCalls.h )

FILE( WRITE ${InstallFunctionDeclarationFile}
  "\n" "//This file is generated by CMake. Do not edit manually!\n\n" )
FILE( WRITE ${InstallFunctionCallFile}
  "\n" "//This file is generated by CMake. Do not edit manually!\n\n" )


#---------------------------------------------------------------------
# Macro that simplifies the addition of elx-components
#
# Usage:
# ADD_ELXCOMPONENT( <name_of_lib> <list_of_source_and_header_files> )
#
# The name_of_lib should be equal to the name of the elx class,
# which also should be the name used in the elxInstallMacro, in the
# the .cxx file of the component.
#

MACRO( ADD_ELXCOMPONENT name )
  # Compile this component or not
  SET( defaultValue ON )
  IF( ${ARGV1} STREQUAL "OFF" )
    SET( defaultValue OFF )
  ENDIF()
  MARK_AS_ADVANCED( USE_${name} )
  OPTION( USE_${name} "Compile this component" ${defaultValue} )

  IF( USE_${name} )
    # Create the list of files which create the library
    SET( filelist ${ARGN} )
    LIST( REMOVE_ITEM filelist "ON" "OFF" )

    # Create project and library
    PROJECT( ${name} )
    ADD_LIBRARY( ${name} STATIC ${filelist} )
    TARGET_LINK_LIBRARIES( ${name} ${elxLinkLibs} )

    # Group in IDE's like Visual Studio
    STRING( REGEX MATCH "[a-zA-Z]+" comp_group ${relative_path_to_comp} )
    SET_PROPERTY( TARGET ${name} PROPERTY FOLDER ${comp_group} )

    # Update AllComponentLibs, while avoiding duplicates:
    IF( DEFINED AllComponentLibs )
      SET( dummy ${AllComponentLibs} )
			IF( NOT "${dummy}" STREQUAL "")
			  LIST( REMOVE_ITEM dummy ${name} )
			ENDIF()
      SET( dummy ${dummy} ${name} )
    ELSE()
      SET( dummy ${name} )
    ENDIF()
    SET( AllComponentLibs ${dummy} CACHE INTERNAL "All component libraries for elastix/transformix" )

    # Write lines to two files
    FILE( APPEND ${InstallFunctionDeclarationFile}
      "elxInstallComponentFunctionDeclarationMacro( " ${name} " );\n\n" )
    FILE( APPEND ${InstallFunctionCallFile}
      "elxInstallComponentFunctionCallMacro( " ${name} " );\n\n" )

  ELSE( USE_${name} )
    # Remove from link list
    IF( DEFINED AllComponentLibs )
      SET( dummy ${AllComponentLibs} )
			IF( NOT "${dummy}" STREQUAL "")
        LIST( REMOVE_ITEM dummy ${name} )
			ENDIF()
    ELSE()
      SET( dummy "" )
    ENDIF()
    SET( AllComponentLibs ${dummy} CACHE INTERNAL "All component libraries for elastix/transformix"  )
  ENDIF()

ENDMACRO( ADD_ELXCOMPONENT )

#---------------------------------------------------------------------
# Search for all components
#

# Initialize the list of link libs.
SET( AllComponentLibs "" CACHE INTERNAL "All component libraries for elastix/transformix"  )

FILE( GLOB_RECURSE ListOfComponents "*/CMakeLists.txt" )

FOREACH( component ${ListOfComponents} )
  GET_FILENAME_COMPONENT( path_to_comp ${component} PATH )
  # Make the path relative to the elxComponents_SOURCE_DIR
  STRING( REGEX REPLACE "${elxComponents_SOURCE_DIR}/" "" relative_path_to_comp ${path_to_comp} )
  ADD_SUBDIRECTORY( ${relative_path_to_comp} )
ENDFOREACH()

#----------------------------------------------------------------------
# Search for user components

FOREACH( userComponentDir ${ELASTIX_USER_COMPONENT_DIRS} )

  MESSAGE( STATUS "Searching for user components in: ${userComponentDir}" )
  FILE( GLOB_RECURSE listOfUserComponents "${userComponentDir}/CMakeLists.txt" )

  FOREACH( userComponent ${listOfUserComponents} )

    GET_FILENAME_COMPONENT( pathToComp ${userComponent} PATH )

    # read project name from cmakelists.txt
    MESSAGE( STATUS "Reading: ${userComponent}" )

    # Find the first line that has the following structure:
    # ADD_ELXCOMPONENT(projectname [....]
    # spaces before/after/inbetween are allowed.
    # ADD_ELXCOMPONENT does not have to be capitalized.
    # Commented lines (where the first nonwhite character is a #) are ignored.
    FILE( STRINGS ${userComponent} addElxComponentLine LIMIT_COUNT 1 REGEX
      "^[ \t]*[Aa][Dd][Dd]_[Ee][Ll][Xx][Cc][Oo][Mm][Pp][Oo][Nn][Ee][Nn][Tt][ \t]*[(][ \t]*[^ #\t()]+" )

    # Extract the projectname.
    STRING(REGEX REPLACE
      "^[ \t]*[Aa][Dd][Dd]_[Ee][Ll][Xx][Cc][Oo][Mm][Pp][Oo][Nn][Ee][Nn][Tt][ \t]*[(][ \t]*([^ #\t()]+).*"
      "\\1" componentName "${addElxComponentLine}")

		IF( NOT "${componentName}" STREQUAL "" )
      MESSAGE( STATUS "Found user component: ${componentName}" )

      # For non-subdirectories, the binarydir should be specified. We use the name
  		# of the component for that.
      SET( binaryDir "${elastix_BINARY_DIR}/UserComponents/${componentName}" )

      # Add
  		ADD_SUBDIRECTORY( ${pathToComp} ${binaryDir} )

		ELSE()
      MESSAGE( STATUS "No user component definition found in: ${userComponent}" )
  	ENDIF()

  ENDFOREACH()
ENDFOREACH()

=== Core/CMakeLists.txt ===
#---------------------------------------------------------------------
PROJECT( elxCore )

#---------------------------------------------------------------------
# Define lists of files in the subdirectories.

SET( KernelFilesForExecutables
  Kernel/elxElastixMain.cxx
  Kernel/elxElastixMain.h
  Kernel/elxTransformixMain.cxx
  Kernel/elxTransformixMain.h
)

SET( KernelFilesForComponents
  Kernel/elxElastixBase.cxx
  Kernel/elxElastixBase.h
  Kernel/elxElastixTemplate.h
  Kernel/elxElastixTemplate.hxx
)

SET( InstallFilesForExecutables
  Install/elxComponentLoader.cxx
  Install/elxComponentLoader.h
)

SET( InstallFilesForComponents
  Install/elxComponentDatabase.cxx
  Install/elxComponentDatabase.h
  Install/elxBaseComponent.h
  Install/elxBaseComponentSE.h
  Install/elxBaseComponentSE.hxx
  Install/elxInstallAllComponents.h
  Install/elxInstallFunctions.h
  Install/elxMacro.h
  Install/elxIncludes.h
  Install/elxSupportedImageTypes.h
)

SET( ConfigurationFiles
  Configuration/elxConfiguration.cxx
  Configuration/elxConfiguration.h
)

SET( ComponentBaseClassFiles
  ComponentBaseClasses/elxFixedImagePyramidBase.h
  ComponentBaseClasses/elxImageSamplerBase.h
  ComponentBaseClasses/elxInterpolatorBase.h
  ComponentBaseClasses/elxMetricBase.h
  ComponentBaseClasses/elxMovingImagePyramidBase.h
  ComponentBaseClasses/elxOptimizerBase.h
  ComponentBaseClasses/elxRegistrationBase.h
  ComponentBaseClasses/elxResampleInterpolatorBase.h
  ComponentBaseClasses/elxResamplerBase.h
  ComponentBaseClasses/elxTransformBase.h
  ComponentBaseClasses/elxFixedImagePyramidBase.hxx
  ComponentBaseClasses/elxImageSamplerBase.hxx
  ComponentBaseClasses/elxInterpolatorBase.hxx
  ComponentBaseClasses/elxMetricBase.hxx
  ComponentBaseClasses/elxMovingImagePyramidBase.hxx
  ComponentBaseClasses/elxOptimizerBase.hxx
  ComponentBaseClasses/elxRegistrationBase.hxx
  ComponentBaseClasses/elxResampleInterpolatorBase.hxx
  ComponentBaseClasses/elxResamplerBase.hxx
  ComponentBaseClasses/elxTransformBase.hxx
)

SET( ProgressCommandFiles
  elxProgressCommand.cxx
  elxProgressCommand.h
)

#---------------------------------------------------------------------
# Construct source groups for nice visualisation in Visual Studio.

SOURCE_GROUP( "Install" FILES
  ${InstallFilesForComponents}
  ${InstallFilesForExecutables}
)

SOURCE_GROUP( "Kernel" FILES
  ${KernelFilesForComponents}
  ${KernelFilesForExecutables}
)

SOURCE_GROUP( "Configuration" FILES ${ConfigurationFiles} )
SOURCE_GROUP( "ComponentBaseClasses" FILES ${ComponentBaseClassFiles} )
SOURCE_GROUP( "ProgressCommand" FILES ${ProgressCommandFiles} )

#---------------------------------------------------------------------
# Create the elxCore library.

ADD_LIBRARY( elxCore
  ${KernelFilesForComponents}
  ${InstallFilesForComponents}
  ${ConfigurationFiles}
  ${ComponentBaseClassFiles}
  ${ProgressCommandFiles}
)

#---------------------------------------------------------------------
# Link against other libraries.

TARGET_LINK_LIBRARIES( elxCore
  elxCommon
  xoutlib
  ITKBasicFilters
  ITKNumerics
  ITKIO
  ITKCommon
)
#param

#---------------------------------------------------------------------
# Add macro if mevisdicomtiff should be used
IF( ELASTIX_USE_MEVISDICOMTIFF )
  ADD_DEFINITIONS( -D_ELASTIX_USE_MEVISDICOMTIFF )
  SET( mevisdcmtifflib mevisdcmtiff )
ELSE()
  SET( mevisdcmtifflib )
ENDIF()


#---------------------------------------------------------------------
# Create the elastix executable.

ADD_EXECUTABLE( elastix
  Main/elastix.cxx
  Main/elastix.h
  Kernel/elxElastixMain.cxx
  Kernel/elxElastixMain.h
  ${InstallFilesForExecutables}
)

#---------------------------------------------------------------------
# Create the transformix executable.

ADD_EXECUTABLE( transformix
  Main/transformix.cxx
  Main/transformix.h
  Kernel/elxElastixMain.cxx
  Kernel/elxElastixMain.h
  Kernel/elxTransformixMain.cxx
  Kernel/elxTransformixMain.h
  ${InstallFilesForExecutables}
)

#---------------------------------------------------------------------
# Link elastix against other libraries.

TARGET_LINK_LIBRARIES( elastix
  elxCommon
  elxCore
  param
  xoutlib
  ${mevisdcmtifflib}
  ITKBasicFilters
  ITKNumerics
  ITKIO
  ITKCommon
  ${AllComponentLibs}
)

#---------------------------------------------------------------------
# Link transformix against other libraries.

TARGET_LINK_LIBRARIES( transformix
  elxCommon
  elxCore
  param
  xoutlib
  ${mevisdcmtifflib}
  ITKBasicFilters
  ITKNumerics
  ITKIO
  ITKCommon
  ${AllComponentLibs}
)

#---------------------------------------------------------------------
# Define the install directory.

IF( WIN32 )
  INSTALL( TARGETS elastix transformix
    RUNTIME DESTINATION . )
    #COMPONENT core )
ELSE()
  INSTALL( TARGETS elastix transformix
    RUNTIME DESTINATION bin )
    #COMPONENT core )
ENDIF()

=== Testing/CMakeLists.txt ===
#---------------------------------------------------------------------
Project( elxTesting )

#---------------------------------------------------------------------
# Macro that simplifies the addition of tests
#
# Usage:
# ADD_ELX_TEST( <name_of_test> )
#
# We assume here that the name of the source which includes the main is:
#   "itk"name_of_test".cxx".
#

MACRO( ADD_ELX_TEST name )

  # Define some helper variables.
  SET( ELXTEST_EXECUTABLE_NAME itk${name} )
  SET( ELXTEST_SOURCE_NAME itk${name}.cxx )
  SET( ELXTEST_TEST_NAME ${name} )

  # Create the test executable.
  ADD_EXECUTABLE( ${ELXTEST_EXECUTABLE_NAME} ${ELXTEST_SOURCE_NAME} )

  # Link against other libraries.
  TARGET_LINK_LIBRARIES( ${ELXTEST_EXECUTABLE_NAME}
    ITKCommon ITKBasicFilters elxCommon )

  # Group in IDE's like Visual Studio
  SET_PROPERTY( TARGET ${ELXTEST_EXECUTABLE_NAME} PROPERTY FOLDER "tests" )

  # Add the test.
  ADD_TEST( ${ELXTEST_TEST_NAME} ${ELXTEST_EXECUTABLE_NAME} ${ARGN} )

ENDMACRO( ADD_ELX_TEST )

#---------------------------------------------------------------------

ADD_ELX_TEST( BSplineDerivativeKernelFunctionTest )
ADD_ELX_TEST( BSplineSODerivativeKernelFunctionTest )
ADD_ELX_TEST( BSplineInterpolationWeightFunctionTest )
ADD_ELX_TEST( BSplineInterpolationDerivativeWeightFunctionTest )
ADD_ELX_TEST( BSplineInterpolationSODerivativeWeightFunctionTest )
ADD_ELX_TEST( AdvancedBSplineDeformableTransformTest ${elastix_SOURCE_DIR}/Testing/parameters_AdvancedBSplineDeformableTransformTest.txt)
ADD_ELX_TEST( TimerTest )

=== Components/Interpolators/ReducedDimensionBSplineInterpolator/CMakeLists.txt ===

ADD_ELXCOMPONENT( ReducedDimensionBSplineInterpolator
 itkReducedDimensionBSplineInterpolateImageFunction.h
 itkReducedDimensionBSplineInterpolateImageFunction.txx
 elxReducedDimensionBSplineInterpolator.h
 elxReducedDimensionBSplineInterpolator.hxx
 elxReducedDimensionBSplineInterpolator.cxx )

=== Components/Resamplers/CUDAResampler/CMakeLists.txt ===
IF( ELASTIX_USE_CUDA )
  ADD_ELXCOMPONENT( CUDAResampler
   elxCUDAResampler.h
   elxCUDAResampler.hxx
   elxCUDAResampler.cxx
   itkCUDAResampleImageFilter.h
   itkCUDAResampleImageFilter.hxx )

  IF( USE_CUDAResampler )
    TARGET_LINK_LIBRARIES( CUDAResampler elastix_cuda )
    INCLUDE_DIRECTORIES( ${CUDA_TOOLKIT_INCLUDE} )
  ENDIF()
ELSE()
  # If the user set USE_CUDAResampler ON, but ELASTIX_USE_CUDA was OFF,
  # then issue a warning.
  IF( USE_CUDAResampler )
    MESSAGE( WARNING "You selected to compile CUDAResampler, "
      "but ELASTIX_USE_CUDA is OFF.\n"
      "Set both options to ON to be able to build this component." )
  ENDIF()

  # If ELASTIX_USE_CUDA is not selected, then the elastix_cuda
  # library is not created, and we cannot compile this component.
  SET( USE_CUDAResampler OFF CACHE BOOL "Compile this component" FORCE )

  # This is required to get the CUDAResampler out of the AllComponentLibs
  # list defined in Components/CMakeLists.txt.
  ADD_ELXCOMPONENT( CUDAResampler elxCUDAResampler.cxx )
ENDIF()

=== debian/changelog ===
elastix (4.4-2) unstable; urgency=low

  [ Andreas Tille ]
  * debian/control:
    - Fix name of Debian Med team (without '-')
    - Added Vcs fields
    - Fix typo in description
      Closes: #613621
  * Added debian/upstream-metadata.yaml
  * Added debian/watch (Thanks to Paul Wise <pabs@debian.org>
    and Daniel Leidert <daniel.leidert@wgdd.de>)

  [ Steve M. Robbins ]
  * target upload to unstable.

 -- Steve M. Robbins <smr@debian.org>  Mon, 21 Feb 2011 10:30:55 -0600

elastix (4.4-1) experimental; urgency=low

  * New package.  Closes: #607030.

 -- Steve M. Robbins <smr@debian.org>  Mon, 27 Dec 2010 06:01:00 -0600

=== debian/control ===
Source: elastix
Homepage: http://elastix.isi.uu.nl/
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>
Build-Depends: quilt, debhelper (>= 8), cmake, 
 libinsighttoolkit3-dev (>= 3.20.0-5), libgdcm2-dev, zlib1g-dev, libpng12-dev, libtiff4-dev
Build-Depends-Indep: doxygen, graphviz, texlive-latex-base, texlive-latex-extra, texlive-latex-recommended, ghostscript
Standards-Version: 3.9.1
Vcs-Svn: svn://svn.debian.org/svn/debian-med/trunk/packages/elastix/trunk/
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/elastix/trunk/?rev=0&sc=0

Package: elastix
Section: science
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: elastix-doc
Description: toolbox for rigid and nonrigid registration of images
 Image registration based on the well-known Insight Segmentation and
 Registration Toolkit (ITK). The software consists of a collection of
 algorithms that are commonly used to solve (medical) image
 registration problems. The modular design of elastix allows the user
 to quickly configure, test, and compare different registration
 methods for a specific application. A command-line interface enables
 automated processing of large numbers of data sets, by means of
 scripting.

Package: elastix-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: toolbox for rigid and nonrigid registration of images - docs
 Image registration based on the well-known Insight Segmentation and
 Registration Toolkit (ITK). The software consists of a collection of
 algorithms that are commonly used to solve (medical) image
 registration problems. The modular design of elastix allows the user
 to quickly configure, test, and compare different registration
 methods for a specific application. A command-line interface enables
 automated processing of large numbers of data sets, by means of
 scripting.
